//+------------------------------------------------------------------+
//|                                        #1EA_Test_Template v1.mq4 |
//|                                        by badguy 13.04.2008      |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""


extern string MAGIC_NUMBER = "Magic Number";
 
extern int MAGICMA               = 13042008;
extern int MAGICMA_Trailing      = 14042008;


extern string ClosingTime  = "ClosingTime";
extern bool UseCloseTime   = True;
extern int CloseTime       = 23;

extern string     P0            =   "LotSize Trailing Position";
double Order_Anzahl_T           =  1;
extern double Order_Lotsize_T   =  0.5;
extern int StopLoss_T           =  100;
extern int TakeProfit_T         =  350;
extern int TrailingStop         =   75;

extern string     P1            =   "LotSize Order_1";
double Order_Anzahl_1           =  1;
extern double Order_Lotsize_1   =  0.5;
extern int StopLoss_1           =  100;
extern int TakeProfit_1         =  150;

            
int slippage=3;

double D_open;
  
int BarShift=1;




//+-----------------------------------------------------------------------+
//| Calculate open positions                                              |
//+-----------------------------------------------------------------------+
int CalculateNumberOfOrders(string symbol)
  {
   int long=0,short=0;
   
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if
      (
      OrderSymbol()==Symbol()
      &&
      OrderMagicNumber()==MAGICMA
      )
        {
         if(OrderType()==OP_BUY)
         {
         long++;
         }
         if(OrderType()==OP_SELL)
         {
         short++;
         }
        }
     }
   if(long>0) return(long);
   else       return(short);
  }

//+-----------------------------------------------------------------------+
//| Calculate open positions                                              |
//+-----------------------------------------------------------------------+
int CalculateNumberOfOrdersTrailing(string symbol)
  {
   int long=0,short=0;
   
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if
      (
      OrderSymbol()==Symbol()
      &&
      OrderMagicNumber()==MAGICMA_Trailing
      )
        {
         if(OrderType()==OP_BUY)
         {
         long++;
         }
         if(OrderType()==OP_SELL)
         {
         short++;
         }
        }
     }
   if(long>0) return(long);
   else       return(short);
  }


//+-----------------------------------------------------------------------+
//| Check for open order conditions                                       |
//+-----------------------------------------------------------------------+

int GetSignal()
{
 double MA_1   = iMA(NULL,0,50,0,2,1,0);
 double MA_2   = iMA(NULL,0,50,0,2,1,1);   

 double D_open  = iOpen(NULL,PERIOD_D1,0);
 
 
   if
   (
     //Daily Buy
     
     (MA_2  <  D_open   && MA_1   >  D_open)

    )
   return(1);



   
   if
   (
     // Daily Sell

     (MA_2  >  D_open   && MA_1   <  D_open) //   || D_PivotSwitch==false)//   && NonLagMA_1<W_open || WO_Switch==1)
                    
   )
   return(2);

   
return(0);

}

//+-----------------------------------------------------------------------+
//| Check for open order conditions                                       |
//+-----------------------------------------------------------------------+
void CheckForOpenConditions()
   { 
   int ticket,i;
  
                  if(GetSignal()==2)
                  {
                     if(Order_Anzahl_1>0)
                     {
                     for( i=1;i<=Order_Anzahl_1;i++)
                        {
                        ticket=OrderSend(Symbol(),OP_BUY,Order_Lotsize_1,Ask,3,
                        Bid-StopLoss_1*Point,
                        Ask+TakeProfit_1*Point,
                        "Buy 1 is active",MAGICMA,0,Green);
                        }
                      }
                          if(Order_Lotsize_T>0)
                           {
                           ticket=OrderSend(Symbol(),OP_BUY,Order_Lotsize_T,Ask,3,
                           Bid-StopLoss_T*Point,
                           Ask+TakeProfit_T*Point,
                           "Buy Trail is active",MAGICMA_Trailing,0,Green);
                           }

                        return(0);
                  }
                  
                  if(GetSignal()==1)
                  {
                     if(Order_Anzahl_T>0)
                     {                  
                     for( i=1;i<=Order_Anzahl_T;i++)
                        {
                        ticket=OrderSend(Symbol(),OP_SELL,Order_Lotsize_T,Bid,3,
                        Ask+StopLoss_T*Point,
                        Bid-TakeProfit_T*Point,
                        "#1 MultiPos Daily Pivot v1.1 ist short",MAGICMA,0,Red);
                        }
                      }
                          if(Order_Lotsize_T>0)                        
                           {
                           ticket=OrderSend(Symbol(),OP_SELL,Order_Lotsize_T,Bid,3,
                           Ask+StopLoss_T*Point,
                           Bid-TakeProfit_T*Point,
                           "#1 MultiPos Daily Pivot v1.1 ist short",MAGICMA_Trailing,0,Red);
                           }

                        return(0);
                  }

   }


//+-----------------------------------------------------------------------+
//| Check for close order conditions                                      |
//+-----------------------------------------------------------------------+
void CheckForCloseConditions()
  { 
  int ticket;
   
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
       { 
            if (GetSignal()==1)
               {
               
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
               return(0);
               }                

       
       
        }
      if(OrderType()==OP_SELL)
        {

            if (GetSignal()==2)
               {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
               return(0);
               }                

         
          }
      }
   return(0);
  }

//+-----------------------------------------------------------------------+
//| Check for close order conditions trailing                             |
//+-----------------------------------------------------------------------+
void CheckForCloseConditionsTrailing()
  { 
  int ticket;
   
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA_Trailing || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
       { 
            if (GetSignal()==1)
               {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
               return(0);
               }                
       
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
       
       
        }
      if(OrderType()==OP_SELL)
        {

            if (GetSignal()==2)
               {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
               return(0);
               }                

            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Magenta);
                     return(0);
                    }
                 }
              }
         
          }
      }
   return(0);
  }

//+-----------------------------------------------------------------------+
//| Start function                                                        |
//+-----------------------------------------------------------------------+

int start()

  {

// delete from here

/*
   
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//Close Open Orders by Time

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

   if (UseCloseTime){
      if (!(Hour()>=CloseTime && Hour()>=CloseTime)) {
         Comment("Time for close trade has come !");
         return(0);
      } else Comment("");
   }else Comment("");


  { 
  int ticket;
   
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
       { 
               {
               
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
               return(0);
               }                

       
       
        }
      if(OrderType()==OP_SELL)
        {

               {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
               return(0);
               }                

         
          }
      }
   return(0);
  }

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//Close Open Trailing Orders by Time

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


   if (UseCloseTime){
      if (!(Hour()>=CloseTime && Hour()>=CloseTime)) {
         Comment("Time for close trailing trade has come !");
         return(0);
      } else Comment("");
   }else Comment("");



   
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        //break;
      if(OrderMagicNumber()!=MAGICMA_Trailing || OrderSymbol()!=Symbol()) //continue;
      if(OrderType()==OP_BUY)
       { 
//            if (GetSignal()==1)
               {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
               return(0);
               }                
       
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
       
       
        }
      if(OrderType()==OP_SELL)
        {

               {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
               return(0);
               }                

            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Magenta);
                     return(0);
                    }
                 }
              }
         
          }
      }
   return(0);
  



// deleted to here

*/



   if(CalculateNumberOfOrders(Symbol())<1&&CalculateNumberOfOrdersTrailing(Symbol())<1) 
   CheckForOpenConditions();
   else
   {
   CheckForCloseConditions();
   CheckForCloseConditionsTrailing();
   }

   
   return(0);
     
 }